#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND TESTED IN A WINDOWS ENVIRONMENT ONLY AND MAY NOT FUNCTION ON A MAC.
#------------------------------------------------------------------------------------------------
#    Name:	Entity Counter
#      By:	sdmitch
#   Usage:	Extensions>Entity Counter
#		 Note:	
#			
#    Date:	Dec 2011
#------------------------------------------------------------------------------------------------
#
require 'Sketchup'
#
if not file_loaded?(File.basename(__FILE__))
	UI.menu("Plugins").add_item("Enity Counter") { SDM_EntCnt.entity_counter }
	file_loaded(File.basename(__FILE__))
end
#
module SDM_EntCnt

	def self.entity_counter
		mod=Sketchup.active_model
		ent=mod.active_entities
		sel=mod.selection
		sel=ent if sel.empty?
		@c_cnt=0;@g_cnt=0;@f_cnt=0;@e_cnt=0;@p_cnt=0;@verts=[]
		recurse(sel)
		@verts.flatten!.uniq!
		UI.messagebox "This model contains:\n\n#{@c_cnt} Components\n#{@g_cnt} Groups\n#{@f_cnt} Faces \
		\n#{@e_cnt} Edges\n#{@verts.length-1} vertices\n#{@p_cnt} Guide Points"
	end
	
	def self.recurse(ents)
		ents.each do |e|
			if e.is_a? Sketchup::Group
				@g_cnt += 1
				recurse(e.entities)
			elsif e.is_a? Sketchup::ComponentInstance
				@c_cnt += 1
				recurse(e.definition.entities)
			elsif e.is_a? Sketchup::Face
				@f_cnt += 1;@verts<<e.vertices
			elsif e.is_a? Sketchup::Edge
				@e_cnt += 1;@verts<<e.vertices
			elsif e.is_a? Sketchup::ConstructionPoint
				@p_cnt += 1
			end
		end
	end
	
end
